--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local addon, ns = ...
local cargBags = ns.cargBags

local InkedBags = cargBags:NewImplementation("InkedBags")	-- Let the magic begin!
local function RegisterBagsToBlizzard()
InkedBags:RegisterBlizzard()
end
function InkedBags:OnInit()
if Inked.db.profile.UseBags == false then  return end  
	-- The filters control which items go into which container
	local INVERTED = -1 -- with inverted filters (using -1), everything goes into this bag when the filter returns false

	local onlyBags =		function(item) return item.bagID >= 0 and item.bagID <= 4 end
	local onlyKeyring =		function(item) return item.bagID == -2 end
	local onlyBank =		function(item) return item.bagID == -1 or item.bagID >= 5 and item.bagID <= 11 end
	local onlyReagent = 	function(item) return item.bagID == -3 end
	local onlyRareEpics =	function(item) return item.rarity and item.rarity > 3 end
	local onlyEpics =		function(item) return item.rarity and item.rarity > 3 end
	
	local onlyCommon =			function(item) return item.rarity and item.rarity == 1 end
	local onlyUncommon =		function(item) return item.rarity and item.rarity == 2 end
	local onlySingleRare =		function(item) return item.rarity and item.rarity == 3 end
	local onlySingleEpics =		function(item) return item.rarity and item.rarity == 4 end
	local onlyLegendary =		function(item) return item.rarity and item.rarity == 5 end
	local onlyArtifact =		function(item) return item.rarity and item.rarity == 6 end
	local onlyLooms =			function(item) return item.rarity and item.rarity == 7 end
	
	
	local hideJunk =		function(item) return not item.rarity or item.rarity > 0 end
	local hideEmpty =		function(item) return item.texture ~= nil end
	local onlyConsumables = function(item) return item.type == Gem end
	--local Junky = function(item) return ItemType == Miscellaneous end
	
	local myConsumables = function(item) return item.type.Consumables end
	
	--local onlyConsumables = function(item) return item.type == Consumable end


	local MyContainer = self:GetContainerClass()
	--local MyEpicContainer = self:GetContainerClass()

	-- Bagpack
	local main = MyContainer:New("Main", {
			Columns = 10,
			Scale = 1,
			Bags = "backpack+bags",
			
		})
		main:SetFilter(onlyBags, true) 
		--main:SetFilter(onlyRareEpics, false) 
		--main:SetFilter(onlyCommon, true)
		main:SetFilter(hideEmpty, false)
		main:SetFilter(onlyLooms, false)
	--	main:SetBags("backpack+bags")
		main:SetPoint("BOTTOMRIGHT", -25, 25)
		
		
		
		
		-- local Uncommonz = MyContainer:New("Uncommons", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Uncommonz:SetFilter(onlyBags, true) 
		-- Uncommonz:SetFilter(onlyUncommon, true) 
		-- Uncommonz:SetFilter(hideEmpty, true)
		-- Uncommonz:SetFilter(onlyLooms, false)

		-- Uncommonz:SetPoint("TOP",main, 0,250)
		
		-- local Rarez = MyContainer:New("Rares", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Rarez:SetFilter(onlyBags, true) 
		-- Rarez:SetFilter(onlyRareEpics) 
		-- Rarez:SetFilter(hideEmpty, true)
		-- Rarez:SetFilter(onlyLooms, false)
		-- Rarez:SetFilter(onlyEpics, false)
		-- Rarez:SetFilter(onlyUncommon, false)
		-- Rarez:SetFilter(onlyCommon, false)

		-- Rarez:SetPoint("TOP",Uncommonz, 0,250)
		
		-- local Epicz = MyContainer:New("Epics", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Epicz:SetFilter(onlyBags, true) 
		-- Epicz:SetFilter(onlyEpics, true) 
		-- Epicz:SetFilter(hideEmpty, true)
		-- Epicz:SetFilter(onlyLooms, false)

		-- Epicz:SetPoint("TOP",Rarez, 0,150)
		
		-- local Legendaryz = MyContainer:New("Legendarys", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Legendaryz:SetFilter(onlyBags, true) 
		-- Legendaryz:SetFilter(onlyLegendary, true) 
		-- Legendaryz:SetFilter(hideEmpty, true)
		-- Legendaryz:SetFilter(onlyLooms, false)

		-- Legendaryz:SetPoint("TOP",Epicz, 0,150)
		
		-- local Artifactz = MyContainer:New("Artifacts", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Artifactz:SetFilter(onlyBags, true) 
		-- Artifactz:SetFilter(onlyArtifact, true) 
		-- Artifactz:SetFilter(hideEmpty, true)
		-- Artifactz:SetFilter(onlyLooms, false)

		-- Artifactz:SetPoint("LEFT",main, -225,0)
		
		-- local Loomz = MyContainer:New("Looms", {
			-- Columns = 14,
			-- Scale = 1,
			-- Bags = "backpack",
		-- })
		-- Loomz:SetFilter(onlyBags, true) 
		-- Loomz:SetFilter(onlyLooms, true) 
		-- Loomz:SetFilter(hideEmpty, true)

		-- Loomz:SetPoint("TOP",Artifactz, 0,200)


	--Bank frame and bank bags
	local bank = MyContainer:New("Bank", {
			Columns = 26,
			Scale = 1,
			Bags = "bankframe+bank",
		})
		bank:SetFilter(onlyBank, true) -- Take only items from the bank frame
		--bank:SetFilter(hideEmpty, true)
		bank:SetPoint("LEFT", 25,-250) -- Place at left side of UI
		
		local Reagentz = MyContainer:New("Reagents", {
			Columns = 26,
			Scale = 1,
			Bags = "bankframe",
		})
		--Reagentz:SetFilter(onlyBank, true) -- Take only items from the bank frame
		Reagentz:SetFilter(onlyReagent, true)
		Reagentz:SetPoint("TOP",bank, 0,250) -- Place at left side of UI
		Reagentz:Hide() -- Hide at the beginning
		bank:Hide() -- Hide at the beginning
		
	
end


function InkedBags:OnBankOpened()
	self:GetContainer("Bank"):Show()
end

function InkedBags:OnBankClosed()
	self:GetContainer("Bank"):Hide()
end
	local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")		
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			if Inked.db.profile.UseBags == false then  
				return        
			end	  
			RegisterBagsToBlizzard()			
		end)